# Telltale

Report Rails application metrics to OpenTSDB.

[![Build Status](https://travis-ci.org/ninech/telltale.svg?branch=master)](https://travis-ci.org/ninech/telltale)
[![Code Climate](https://codeclimate.com/github/ninech/telltale/badges/gpa.svg)](https://codeclimate.com/github/ninech/telltale)

## Instructions

Add the following line to your `Gemfile` and run `bundle install`.

```ruby
gem 'telltale'
```

Then set the environment variables and run your rails app:

```sh
TELLTALE_OPENTSDB_HOST=metrics.domain.com bundle exec rails s
```

It is recommended to use something like [dotenv](https://rubygems.org/gems/dotenv) to manage your app's
environment variables.

## Metrics

These numbers are currently reported:

* `<prefix>.rails.total_time`: Total request time in seconds
* `<prefix>.rails.request_count`: A counter for requests (always 1)

The default `prefix` is "telltale" and can be configured with the environment variable `TELLTALE_PREFIX`.

## Tags

The following tags are available for all metrics:

* `http_status`: HTTP Status code
* `controller`: Name of the controller
* `action`: Name of the action in the form `controller_name.action_name`
* `host`: Name of the host the Rails app is running on
* `environment`: The Rails app environment
* `app`: The application's name

## Configuration

Telltale uses the following environment variables for configuration:

* `TELLTALE_OPENTSDB_HOST`: The host to report to
* `TELLTALE_OPENTSDB_PORT`: The port opentsdb listens on. Default is 4242
* `TELLTALE_PREFIX`: Some prefix for the metric name. Default is `telltale`

## Contributing

1. Fork it
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Added some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create new Pull Request

## About

This Gem is maintained and funded by nine.ch.

![nine.ch](https://blog.nine.ch/assets/logo.png)

We run your Linux server infrastructure – without interruptions, around the clock
